// Rex Hill, console application

#include "stdafx.h"

// small exponent  10 times 10 to the X power
unsigned short exponent(unsigned char input)
{
	unsigned short i,value=1;
	if(input >= 2)
		for(i=2;i <= input;i++)
			value = value * 10;
	return value;
}


int main(int argc, char* argv[]) //argc is number of commands including program name
{
	char var2[5] = {0};
	if(argc <= 2)
	{
		cout << "***ERROR***  Please supply a file name and an integer:\n\t Useage:  forcematid.exe filename.sm [matid to overwrite with]\n\n";
		return 0;
	}

	strcpy(var2,argv[2]);
	fstream fin(argv[1], ios::in | ios::out | ios::binary | ios::nocreate);

	long nextoffset, numFaces, numModels, i,n;
	unsigned short matidReplace=0;
	unsigned char numvars,headerV;

//**HEADER
	fin.get(headerV);
	fin.seekg(32); // absolute seek
	if (headerV <= 10 && headerV >= 9)
	{
		if ( headerV == 10)
		{
			fin.seekg(33); //absolute seek
			fin.read((char*)&numModels,4);
		}		
		else fin.read((char*)&numModels,4);

		if(numModels > 0 && numModels < 240)
		{
			fin.read((char*)&nextoffset,4);
			nextoffset = fin.tellg() + nextoffset;
			cout << " numModels: " << numModels << endl;

			numvars = 0;
			for(i=0;i <= 4; i++)
				if((var2[i]-48) >= 0 && (var2[i]-48) <= 9)
					numvars++;

			//	cout << "numvars: " << (short)numvars << endl;
			n = numvars;
			for(i=1;i <= numvars; i++)
			{
				matidReplace +=
					(var2[((unsigned char)i-1)]-48)*exponent((unsigned char)n);
				n--;
			}

			cout << " matidReplace: " << matidReplace << endl;
			if(matidReplace > 65535)
			{
				cout << "Supply a matID less than 65536 please\nYou supplied: " << argv[2] << endl;
				return 0;
			}

			for(n=1;n <= numModels; n++)
			{
				fin.seekg(8, ios::cur); // fly past first junk
				fin.read((char*)&numFaces,4);// read vertices and skip
				fin.seekg((numFaces*16), ios::cur);

				fin.read((char*)&numFaces,4);
				for(i=1; i <= numFaces; i++)
				{
					fin.seekg(6, ios::cur);
					fin.write((char*)&matidReplace ,2);
				}


				fin.seekg(40,ios::cur);
				for(i=1;i <= numFaces; i++)
				{		
					fin.write((char*)&matidReplace ,2);
					fin.seekg(30,ios::cur);
				}

				fin.seekg(nextoffset);
				fin.read((char*)&nextoffset,4);
				nextoffset = fin.tellg() + nextoffset;
			}
		}
		else
			cout << "I found not one or too many collision models in this file\n" ;
	}
	else
		cout << "invalid .sm file\n";

	cout << "<<done>>\n";
	fin.close();	
	return 0;
}

